unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, WinCrypt;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Button3: TButton;
    Open1: TOpenDialog;
    Button4: TButton;
    Label2: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  provider = 'Crypto-Pro Cryptographic Service Provider';
  conteiner = 'TestConteiner';

  PROV_GOST_DH = 2;
  ALG_SID_G28147 = 30;
  CALG_G28147 = ALG_CLASS_DATA_ENCRYPT or ALG_TYPE_BLOCK or ALG_SID_G28147;

  ALG_SID_DH_EX_SF = 30;
  CALG_DH_EX_SF = ALG_CLASS_KEY_EXCHANGE or ALG_TYPE_DH or ALG_SID_DH_EX_SF;

  AT = CALG_DH_EX_SF;
  //AT = AT_KEYEXCHANGE;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function ErrToStr(e: int64): string;
begin
case e of
ERROR_BUSY: ErrToStr := 'ERROR_BUSY';
ERROR_CALL_NOT_IMPLEMENTED: ErrToStr := 'ERROR_CALL_NOT_IMPLEMENTED';
ERROR_INVALID_HANDLE: ErrToStr := 'ERROR_INVALID_HANDLE';
ERROR_INVALID_PARAMETER: ErrToStr := 'ERROR_INVALID_PARAMETER';
ERROR_MORE_DATA: ErrToStr := 'ERROR_MORE_DATA';
ERROR_NO_MORE_ITEMS: ErrToStr := 'ERROR_NO_MORE_ITEMS';
ERROR_NOT_ENOUGH_MEMORY: ErrToStr := 'ERROR_NOT_ENOUGH_MEMORY';
NTE_BAD_ALGID: ErrToStr := 'NTE_BAD_ALGID';
NTE_BAD_DATA: ErrToStr := 'NTE_BAD_DATA';
NTE_BAD_FLAGS: ErrToStr := 'NTE_BAD_FLAGS';
NTE_BAD_HASH: ErrToStr := 'NTE_BAD_HASH';
NTE_BAD_HASH_STATE: ErrToStr := 'NTE_BAD_HASH_STATE';
NTE_BAD_KEY: ErrToStr := 'NTE_BAD_KEY';
NTE_BAD_KEYSET: ErrToStr := 'NTE_BAD_KEYSET';
NTE_BAD_KEYSET_PARAM: ErrToStr := 'NTE_BAD_KEYSET_PARAM';
NTE_BAD_LEN: ErrToStr := 'NTE_BAD_LEN';
NTE_BAD_PROV_TYPE: ErrToStr := 'NTE_BAD_PROV_TYPE';
NTE_BAD_PUBLIC_KEY: ErrToStr := 'NTE_BAD_PUBLIC_KEY';
NTE_BAD_SIGNATURE: ErrToStr := 'NTE_BAD_SIGNATURE';
NTE_BAD_TYPE: ErrToStr := 'NTE_BAD_TYPE';
NTE_BAD_UID: ErrToStr := 'NTE_BAD_UID';
NTE_DOUBLE_ENCRYPT: ErrToStr := 'NTE_DOUBLE_ENCRYPT';
NTE_EXISTS: ErrToStr := 'NTE_EXISTS';
NTE_FAIL: ErrToStr := 'NTE_FAIL';
NTE_KEYSET_ENTRY_BAD: ErrToStr := 'NTE_KEYSET_ENTRY_BAD';
NTE_KEYSET_NOT_DEF: ErrToStr := 'NTE_KEYSET_NOT_DEF';
NTE_NO_KEY: ErrToStr := 'NTE_NO_KEY';
NTE_NO_MEMORY: ErrToStr := 'NTE_NO_MEMORY';
NTE_PROV_DLL_NOT_FOUND: ErrToStr := 'NTE_PROV_DLL_NOT_FOUND';
NTE_PROV_TYPE_ENTRY_BAD: ErrToStr := 'NTE_PROV_TYPE_ENTRY_BAD';
NTE_PROV_TYPE_NO_MATCH: ErrToStr := 'NTE_PROV_TYPE_NO_MATCH';
NTE_PROV_TYPE_NOT_DEF: ErrToStr := 'NTE_PROV_TYPE_NOT_DEF';
NTE_PROVIDER_DLL_FAIL: ErrToStr := 'NTE_PROVIDER_DLL_FAIL';
NTE_SIGNATURE_FILE_BAD: ErrToStr := 'NTE_SIGNATURE_FILE_BAD';
NTE_BAD_KEY_STATE: ErrToStr := 'NTE_BAD_KEY_STATE';
else ErrToStr := 'unknown error';
end;
end;

procedure ShowErr;
begin
  MessageDlg(': ' + ErrToStr(GetLastError), mtError, [mbOK], 0);
end;

function EncryptFile(filename:string):boolean;
var
  hProv: HCRYPTPROV;
  SessionKey,PublicKey,ExchKey: HCRYPTKEY;

  f:file;
  KeyBuf, FileBuf:array of byte;
  KeyBufSize, FileBufSize:longword;
begin
  result := false;

  try
    assignfile(f, filename);
    reset(f,1);
    FileBufSize := filesize(f);
    setlength(FileBuf, FileBufSize);
    blockread(f, FileBuf[0], FileBufSize);
    closefile(f);
  except
    MessageDlg('   ' + filename, mtError, [mbOK], 0);
    exit;
  end;

  if not CryptAcquireContext(hProv, pchar(conteiner), pchar(provider), PROV_GOST_DH, 0) then
    if not CryptAcquireContext(hProv, pchar(conteiner), pchar(provider), PROV_GOST_DH, CRYPT_NEWKEYSET) then
      begin
      ShowErr;
      exit;
      end;
  if not CryptGetUserKey(hProv, AT, PublicKey) then
    begin
    ShowErr;
    exit;
    end;
  KeyBufSize := 0;
  if not CryptExportKey(PublicKey, 0, PUBLICKEYBLOB, 0, nil, KeyBufSize) then
    begin
    ShowErr;
    exit;
    end;
  setlength(KeyBuf, KeyBufSize);
  if not CryptExportKey(PublicKey, 0, PUBLICKEYBLOB, 0, @KeyBuf[0], KeyBufSize) then
    begin
    ShowErr;
    exit;
    end;
  if not CryptImportKey(hProv, @KeyBuf[0], KeyBufSize, PublicKey, 0, ExchKey) then
    begin
    ShowErr;
    exit;
    end;

  if not CryptGenKey(hProv, CALG_G28147, CRYPT_EXPORTABLE, SessionKey) then
    begin
    ShowErr;
    exit;
    end;
  KeyBufSize := 0;
  if not CryptExportKey(SessionKey, ExchKey, SIMPLEBLOB, 0, nil, KeyBufSize) then
    begin
    ShowErr;
    exit;
    end;
  setlength(KeyBuf, KeyBufSize);
  if not CryptExportKey(SessionKey, ExchKey, SIMPLEBLOB, 0, @KeyBuf[0], KeyBufSize) then
    begin
    ShowErr;
    exit;
    end;
  if not CryptEncrypt(SessionKey, 0, true, 0, @FileBuf[0], FileBufSize, FileBufSize) then
    begin
    ShowErr;
    exit;
    end;
  if not CryptReleaseContext(hProv, 0) then
    begin
    ShowErr;
    exit;
    end;

  try
    rewrite(f,1);
    blockwrite(f, KeyBufSize, 4);
    blockwrite(f, KeyBuf[0], KeyBufSize);
    blockwrite(f, FileBufSize, 4);
    blockwrite(f, FileBuf[0], FileBufSize);
    closefile(f);
  except
    MessageDlg('   ' + filename, mtError, [mbOK], 0);
    exit;
  end;

  result := true;
end;

function DecryptFile(filename:string):boolean;
var
  hProv: HCRYPTPROV;
  SessionKey,PublicKey,ExchKey: HCRYPTKEY;

  f:file;
  KeyBuf, FileBuf:array of byte;
  KeyBufSize, FileBufSize:longword;
begin
  result := false;

  if not CryptAcquireContext(hProv, pchar(conteiner), pchar(provider), PROV_GOST_DH, 0) then
    begin
    ShowErr;
    exit;
    end;
  if not CryptGetUserKey(hProv, AT, PublicKey) then
    begin
    ShowErr;
    exit;
    end;
  KeyBufSize := 0;
  if not CryptExportKey(PublicKey, 0, PUBLICKEYBLOB, 0, nil, KeyBufSize) then
    begin
    ShowErr;
    exit;
    end;
  setlength(KeyBuf, KeyBufSize);
  if not CryptExportKey(PublicKey, 0, PUBLICKEYBLOB, 0, @KeyBuf[0], KeyBufSize) then
    begin
    ShowErr;
    exit;
    end;
  if not CryptImportKey(hProv, @KeyBuf[0], KeyBufSize, PublicKey, 0, ExchKey) then
    begin
    ShowErr;
    exit;
    end;

  try
    assignfile(f, filename);
    reset(f,1);
    blockread(f, KeyBufSize, 4);
    setlength(KeyBuf, KeyBufSize);
    blockread(f, KeyBuf[0], KeyBufSize);
    blockread(f, FileBufSize, 4);
    setlength(FileBuf, FileBufSize);
    blockread(f, FileBuf[0], FileBufSize);
    closefile(f);
  except
    MessageDlg('   ' + filename, mtError, [mbOK], 0);
    exit;
  end;

  if not CryptImportKey(hProv, @KeyBuf[0], KeyBufSize, ExchKey, 0, SessionKey) then
    begin
    ShowErr;
    exit;
    end;
  if not CryptDecrypt(SessionKey, 0, true, 0, @FileBuf[0], FileBufSize) then
    begin
    ShowErr;
    exit;
    end;
  if not CryptReleaseContext(hProv, 0) then
    begin
    ShowErr;
    exit;
    end;

  try
    rewrite(f,1);
    blockwrite(f, FileBuf[0], FileBufSize);
    closefile(f);
  except
    MessageDlg('   ' + filename, mtError, [mbOK], 0);
    exit;
  end;

  result := true;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if EncryptFile(edit1.Text) then
    Label2.Caption := ' !';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if DecryptFile(edit1.Text) then
    Label2.Caption := ' !';
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if open1.Execute then
    edit1.Text := open1.FileName;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  close;
end;

end.
